Loading...
Searching...
No Matches
wayland::server::xdg_toplevel_t Class Reference

toplevel surface More...

`#include <wayland-server-protocol-extra.hpp>`

Inherits wayland::server::resource_t.

## Public Member Functions

std::function< void()> & | on_destroy ()
| destroy the xdg_toplevel
std::function< void(xdg_toplevel_t)> & | on_set_parent ()
| set the parent of this surface
std::function< void(std::string)> & | on_set_title ()
| set surface title
std::function< void(std::string)> & | on_set_app_id ()
| set application ID
std::function< void(seat_t, uint32_t, int32_t, int32_t)> & | on_show_window_menu ()
| show the window menu
std::function< void(seat_t, uint32_t)> & | on_move ()
| start an interactive move
std::function< void(seat_t, uint32_t, xdg_toplevel_resize_edge)> & | on_resize ()
| start an interactive resize
std::function< void(int32_t, int32_t)> & | on_set_max_size ()
| set the maximum size
std::function< void(int32_t, int32_t)> & | on_set_min_size ()
| set the minimum size
std::function< void()> & | on_set_maximized ()
| maximize the window
std::function< void()> & | on_unset_maximized ()
| unmaximize the window
std::function< void(output_t)> & | on_set_fullscreen ()
| set the window as fullscreen on an output
std::function< void()> & | on_unset_fullscreen ()
| unset the window as fullscreen
std::function< void()> & | on_set_minimized ()
| set the window as minimized
void | configure (int32_t width, int32_t height, array_t const &states, bool post=true)
| suggest a surface change
void | close (bool post=true)
| surface wants to be closed
void | configure_bounds (int32_t width, int32_t height, bool post=true)
| recommended window geometry bounds
bool | can_configure_bounds () const
| Check whether the configure_bounds function is available with the currently bound version of the protocol.
void | post_invalid_resize_edge (std::string const &msg)
| Post error: provided value is not a valid variant of the resize_edge enum.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
void | post_no_memory () const
uint32_t | get_id () const
client_t | get_client () const
unsigned int | get_version () const
std::string | get_class ()

## Static Public Attributes

static constexpr std::uint32_t | configure_since_version = 1
| Minimum protocol version required for the configure function.
static constexpr std::uint32_t | close_since_version = 1
| Minimum protocol version required for the close function.
static constexpr std::uint32_t | configure_bounds_since_version = 4
| Minimum protocol version required for the configure_bounds function.

## Detailed Description

toplevel surface

This interface defines an xdg_surface role which allows a surface to, among other things, set window-like properties such as maximize, fullscreen, and minimize, set application-specific metadata like title and id, and well as trigger user interactive operations such as interactive resize and move.

Unmapping an xdg_toplevel means that the surface cannot be shown by the compositor until it is explicitly mapped again. All active operations (e.g., move, resize) are canceled and all attributes (e.g. title, state, stacking, ...) are discarded for an xdg_toplevel surface when it is unmapped. The xdg_toplevel returns to the state it had right after xdg_surface.get_toplevel. The client can re-map the toplevel by perfoming a commit without any buffer attached, waiting for a configure event and handling it as usual (see xdg_surface description).

Attaching a null buffer to a toplevel unmaps the surface.

Definition at line 1300 of file wayland-server-protocol-extra.hpp.

## Member Function Documentation

## can_configure_bounds()

bool xdg_toplevel_t::can_configure_bounds | ( |  | ) | const

Check whether the configure_bounds function is available with the currently bound version of the protocol.

Definition at line 1351 of file wayland-server-protocol-extra.cpp.

## close()

void xdg_toplevel_t::close | ( | bool | post = `true` | ) |

surface wants to be closed

The close event is sent by the compositor when the user wants the surface to be closed. This should be equivalent to the user clicking the close button in client-side decorations, if your application has any.

This is only a request that the user intends to close the window. The client may choose to ignore this request, or show a dialog to ask the user to save their data, etc.

Definition at line 1341 of file wayland-server-protocol-extra.cpp.

## configure()

void xdg_toplevel_t::configure | ( | int32_t | width,
|  | int32_t | height,
|  | array_t const & | states,
|  | bool | post = `true`
| ) |  |

suggest a surface change

Parameters

  width |
  height |
  states |

This configure event asks the client to resize its toplevel surface or to change its state. The configured state should not be applied immediately. See xdg_surface.configure for details.

The width and height arguments specify a hint to the window about how its surface should be resized in window geometry coordinates. See set_window_geometry.

If the width or height arguments are zero, it means the client should decide its own window dimension. This may happen when the compositor needs to configure the state of the surface but doesn't have any information about any previous or expected dimension.

The states listed in the event specify how the width/height arguments should be interpreted, and possibly how it should be drawn.

Clients must send an ack_configure in response to this event. See xdg_surface.configure and xdg_surface.ack_configure for details.

Definition at line 1336 of file wayland-server-protocol-extra.cpp.

## configure_bounds()

void xdg_toplevel_t::configure_bounds | ( | int32_t | width,
|  | int32_t | height,
|  | bool | post = `true`
| ) |  |

recommended window geometry bounds

Parameters

  width |
  height |

The configure_bounds event may be sent prior to a xdg_toplevel.configure event to communicate the bounds a window geometry size is recommended to constrain to.

The passed width and height are in surface coordinate space. If width and height are 0, it means bounds is unknown and equivalent to as if no configure_bounds event was ever sent for this surface.

The bounds can for example correspond to the size of a monitor excluding any panels or other shell components, so that a surface isn't created in a way that it cannot fit.

The bounds may change at any point, and in such a case, a new xdg_toplevel.configure_bounds will be sent, followed by xdg_toplevel.configure and xdg_surface.configure.

Definition at line 1346 of file wayland-server-protocol-extra.cpp.

## get_class()

std::string wayland::server::resource_t::get_class | ( |  | ) |

inherited

Retrieve the interface name (class) of a resource object.

Returns
  Interface name of the resource object.

## get_client()

client_t wayland::server::resource_t::get_client | ( |  | ) | const

inherited

Get the associated client

Returns
  the client that owns the resource.

## get_id()

uint32_t wayland::server::resource_t::get_id | ( |  | ) | const

inherited

Get the internal ID of the resource

Returns
  the internal ID of the resource

## get_version()

unsigned int wayland::server::resource_t::get_version | ( |  | ) | const

inherited

Get interface version

Returns
  Interface version this resource has been constructed with.

## on_destroy()

std::function< void()> & xdg_toplevel_t::on_destroy | ( |  | ) |

destroy the xdg_toplevel

This request destroys the role surface and unmaps the surface; see "Unmapping" behavior in interface section for details.

Definition at line 1252 of file wayland-server-protocol-extra.cpp.

## on_move()

std::function< void(seat_t, uint32_t)> & xdg_toplevel_t::on_move | ( |  | ) |

start an interactive move

Parameters

  seat | the wl_seat of the user event
  serial | the serial of the user event

Start an interactive, user-driven move of the surface.

This request must be used in response to some sort of user action like a button press, key press, or touch down event. The passed serial is used to determine the type of interactive move (touch, pointer, etc).

The server may ignore move requests depending on the state of the surface (e.g. fullscreen or maximized), or if the passed serial is no longer valid.

If triggered, the surface will lose the focus of the device (wl_pointer, wl_touch, etc) used for the move. It is up to the compositor to visually indicate that the move is taking place, such as updating a pointer cursor, during the move. There is no guarantee that the device focus will return when the move is completed.

Definition at line 1282 of file wayland-server-protocol-extra.cpp.

## on_resize()

std::function< void(seat_t, uint32_t, xdg_toplevel_resize_edge)> & xdg_toplevel_t::on_resize | ( |  | ) |

start an interactive resize

Parameters

  seat | the wl_seat of the user event
  serial | the serial of the user event
  edges | which edge or corner is being dragged

Start a user-driven, interactive resize of the surface.

This request must be used in response to some sort of user action like a button press, key press, or touch down event. The passed serial is used to determine the type of interactive resize (touch, pointer, etc).

The server may ignore resize requests depending on the state of the surface (e.g. fullscreen or maximized).

If triggered, the client will receive configure events with the "resize" state enum value and the expected sizes. See the "resize" enum value for more details about what is required. The client must also acknowledge configure events using "ack_configure". After the resize is completed, the client will receive another "configure" event without the resize state.

If triggered, the surface also will lose the focus of the device (wl_pointer, wl_touch, etc) used for the resize. It is up to the compositor to visually indicate that the resize is taking place, such as updating a pointer cursor, during the resize. There is no guarantee that the device focus will return when the resize is completed.

The edges parameter specifies how the surface should be resized, and is one of the values of the resize_edge enum. Values not matching a variant of the enum will cause a protocol error. The compositor may use this information to update the surface position for example when dragging the top left corner. The compositor may also use this information to adapt its behavior, e.g. choose an appropriate cursor image.

Definition at line 1288 of file wayland-server-protocol-extra.cpp.

## on_set_app_id()

std::function< void(std::string)> & xdg_toplevel_t::on_set_app_id | ( |  | ) |

set application ID

Parameters

  app_id |

Set an application identifier for the surface.

The app ID identifies the general class of applications to which the surface belongs. The compositor can use this to group multiple surfaces together, or to determine how to launch a new application.

For D-Bus activatable applications, the app ID is used as the D-Bus service name.

The compositor shell will try to group application surfaces together by their app ID. As a best practice, it is suggested to select app ID's that match the basename of the application's .desktop file. For example, "org.freedesktop.FooViewer" where the .desktop file is "org.freedesktop.FooViewer.desktop".

Like other properties, a set_app_id request can be sent after the xdg_toplevel has been mapped to update the property.

See the desktop-entry specification [0] for more details on application identifiers and how they relate to well-known D-Bus names and .desktop files.

[0] http://standards.freedesktop.org/desktop-entry-spec/

Definition at line 1270 of file wayland-server-protocol-extra.cpp.

## on_set_fullscreen()

std::function< void(output_t)> & xdg_toplevel_t::on_set_fullscreen | ( |  | ) |

set the window as fullscreen on an output

Parameters

  output |

Make the surface fullscreen.

After requesting that the surface should be fullscreened, the compositor will respond by emitting a configure event. Whether the client is actually put into a fullscreen state is subject to compositor policies. The client must also acknowledge the configure when committing the new content (see ack_configure).

The output passed by the request indicates the client's preference as to which display it should be set fullscreen on. If this value is NULL, it's up to the compositor to choose which display will be used to map this surface.

If the surface doesn't cover the whole output, the compositor will position the surface in the center of the output and compensate with with border fill covering the rest of the output. The content of the border fill is undefined, but should be assumed to be in some way that attempts to blend into the surrounding area (e.g. solid black).

If the fullscreened surface is not opaque, the compositor must make sure that other screen content not part of the same surface tree (made up of subsurfaces, popups or similarly coupled surfaces) are not visible below the fullscreened surface.

Definition at line 1318 of file wayland-server-protocol-extra.cpp.

## on_set_max_size()

std::function< void(int32_t, int32_t)> & xdg_toplevel_t::on_set_max_size | ( |  | ) |

set the maximum size

Parameters

  width |
  height |

Set a maximum size for the window.

The client can specify a maximum size so that the compositor does not try to configure the window beyond this size.

The width and height arguments are in window geometry coordinates. See xdg_surface.set_window_geometry.

Values set in this way are double-buffered. They will get applied on the next commit.

The compositor can use this information to allow or disallow different states like maximize or fullscreen and draw accurate animations.

Similarly, a tiling window manager may use this information to place and resize client windows in a more effective way.

The client should not rely on the compositor to obey the maximum size. The compositor may decide to ignore the values set by the client and request a larger size.

If never set, or a value of zero in the request, means that the client has no expected maximum size in the given dimension. As a result, a client wishing to reset the maximum size to an unspecified state can use zero for width and height in the request.

Requesting a maximum size to be smaller than the minimum size of a surface is illegal and will result in a protocol error.

The width and height must be greater than or equal to zero. Using strictly negative values for width and height will result in a protocol error.

Definition at line 1294 of file wayland-server-protocol-extra.cpp.

## on_set_maximized()

std::function< void()> & xdg_toplevel_t::on_set_maximized | ( |  | ) |

maximize the window

Maximize the surface.

After requesting that the surface should be maximized, the compositor will respond by emitting a configure event. Whether this configure actually sets the window maximized is subject to compositor policies. The client must then update its content, drawing in the configured state. The client must also acknowledge the configure when committing the new content (see ack_configure).

It is up to the compositor to decide how and where to maximize the surface, for example which output and what region of the screen should be used.

If the surface was already maximized, the compositor will still emit a configure event with the "maximized" state.

If the surface is in a fullscreen state, this request has no direct effect. It may alter the state the surface is returned to when unmaximized unless overridden by the compositor.

Definition at line 1306 of file wayland-server-protocol-extra.cpp.

## on_set_min_size()

std::function< void(int32_t, int32_t)> & xdg_toplevel_t::on_set_min_size | ( |  | ) |

set the minimum size

Parameters

  width |
  height |

Set a minimum size for the window.

The client can specify a minimum size so that the compositor does not try to configure the window below this size.

The width and height arguments are in window geometry coordinates. See xdg_surface.set_window_geometry.

Values set in this way are double-buffered. They will get applied on the next commit.

The compositor can use this information to allow or disallow different states like maximize or fullscreen and draw accurate animations.

Similarly, a tiling window manager may use this information to place and resize client windows in a more effective way.

The client should not rely on the compositor to obey the minimum size. The compositor may decide to ignore the values set by the client and request a smaller size.

If never set, or a value of zero in the request, means that the client has no expected minimum size in the given dimension. As a result, a client wishing to reset the minimum size to an unspecified state can use zero for width and height in the request.

Requesting a minimum size to be larger than the maximum size of a surface is illegal and will result in a protocol error.

The width and height must be greater than or equal to zero. Using strictly negative values for width and height will result in a protocol error.

Definition at line 1300 of file wayland-server-protocol-extra.cpp.

## on_set_minimized()

std::function< void()> & xdg_toplevel_t::on_set_minimized | ( |  | ) |

set the window as minimized

Request that the compositor minimize your surface. There is no way to know if the surface is currently minimized, nor is there any way to unset minimization on this surface.

If you are looking to throttle redrawing when minimized, please instead use the wl_surface.frame event for this, as this will also work with live previews on windows in Alt-Tab, Expose or similar compositor features.

Definition at line 1330 of file wayland-server-protocol-extra.cpp.

## on_set_parent()

std::function< void(xdg_toplevel_t)> & xdg_toplevel_t::on_set_parent | ( |  | ) |

set the parent of this surface

Parameters

  parent |

Set the "parent" of this surface. This surface should be stacked above the parent surface and all other ancestor surfaces.

Parent windows should be set on dialogs, toolboxes, or other "auxiliary" surfaces, so that the parent is raised when the dialog is raised.

Setting a null parent for a child window removes any parent-child relationship for the child. Setting a null parent for a window which currently has no parent is a no-op.

If the parent is unmapped then its children are managed as though the parent of the now-unmapped parent has become the parent of this surface. If no parent exists for the now-unmapped parent then the children are managed as though they have no parent surface.

Definition at line 1258 of file wayland-server-protocol-extra.cpp.

## on_set_title()

std::function< void(std::string)> & xdg_toplevel_t::on_set_title | ( |  | ) |

set surface title

Parameters

  title |

Set a short title for the surface.

This string may be used to identify the surface in a task bar, window list, or other user interface elements provided by the compositor.

The string must be encoded in UTF-8.

Definition at line 1264 of file wayland-server-protocol-extra.cpp.

## on_show_window_menu()

std::function< void(seat_t, uint32_t, int32_t, int32_t)> & xdg_toplevel_t::on_show_window_menu | ( |  | ) |

show the window menu

Parameters

  seat | the wl_seat of the user event
  serial | the serial of the user event
  x | the x position to pop up the window menu at
  y | the y position to pop up the window menu at

Clients implementing client-side decorations might want to show a context menu when right-clicking on the decorations, giving the user a menu that they can use to maximize or minimize the window.

This request asks the compositor to pop up such a window menu at the given position, relative to the local surface coordinates of the parent surface. There are no guarantees as to what menu items the window menu contains.

This request must be used in response to some sort of user action like a button press, key press, or touch down event.

Definition at line 1276 of file wayland-server-protocol-extra.cpp.

## on_unset_fullscreen()

std::function< void()> & xdg_toplevel_t::on_unset_fullscreen | ( |  | ) |

unset the window as fullscreen

Make the surface no longer fullscreen.

After requesting that the surface should be unfullscreened, the compositor will respond by emitting a configure event. Whether this actually removes the fullscreen state of the client is subject to compositor policies.

Making a surface unfullscreen sets states for the surface based on the following: the state(s) it may have had before becoming fullscreen any state(s) decided by the compositor any state(s) requested by the client while the surface was fullscreen

The compositor may include the previous window geometry dimensions in the configure event, if applicable.

The client must also acknowledge the configure when committing the new content (see ack_configure).

Definition at line 1324 of file wayland-server-protocol-extra.cpp.

## on_unset_maximized()

std::function< void()> & xdg_toplevel_t::on_unset_maximized | ( |  | ) |

unmaximize the window

Unmaximize the surface.

After requesting that the surface should be unmaximized, the compositor will respond by emitting a configure event. Whether this actually un-maximizes the window is subject to compositor policies. If available and applicable, the compositor will include the window geometry dimensions the window had prior to being maximized in the configure event. The client must then update its content, drawing it in the configured state. The client must also acknowledge the configure when committing the new content (see ack_configure).

It is up to the compositor to position the surface after it was unmaximized; usually the position the surface had before maximizing, if applicable.

If the surface was already not maximized, the compositor will still emit a configure event without the "maximized" state.

If the surface is in a fullscreen state, this request has no direct effect. It may alter the state the surface is returned to when unmaximized unless overridden by the compositor.

Definition at line 1312 of file wayland-server-protocol-extra.cpp.

## post_invalid_resize_edge()

void xdg_toplevel_t::post_invalid_resize_edge | ( | std::string const & | msg | ) |

Post error: provided value is not a valid variant of the resize_edge enum.

Definition at line 1356 of file wayland-server-protocol-extra.cpp.

## post_no_memory()

void wayland::server::resource_t::post_no_memory | ( |  | ) | const

inherited

Post "not enough memory" error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

## proxy_has_object()

bool wayland::server::resource_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## Member Data Documentation

## close_since_version

constexpr std::uint32_t wayland::server::xdg_toplevel_t::close_since_version = 1

static constexpr

Minimum protocol version required for the close function.

Definition at line 1750 of file wayland-server-protocol-extra.hpp.

## configure_bounds_since_version

constexpr std::uint32_t wayland::server::xdg_toplevel_t::configure_bounds_since_version = 4

static constexpr

Minimum protocol version required for the configure_bounds function.

Definition at line 1777 of file wayland-server-protocol-extra.hpp.

## configure_since_version

constexpr std::uint32_t wayland::server::xdg_toplevel_t::configure_since_version = 1

static constexpr

Minimum protocol version required for the configure function.

Definition at line 1732 of file wayland-server-protocol-extra.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-server-protocol-extra.hpp
- obj-x86_64-linux-gnu/wayland-server-protocol-extra.cpp